#pragma once

class AsyncShellIcon;

struct FileInfo
{
					FileInfo();
					~FileInfo() {}
	bool			EnsureSysIcon( HWND hwndNotify );

	Str				m_sFile;
	Str				m_sPath;
	DWORD			m_attr;
	FILETIME		m_ft;
	ULARGE_INTEGER	m_uliFileSize;
	DWORD			m_iImage;
	bool			m_fEnsuredIcon;
	bool			m_fFromFileSystem;
	AsyncShellIcon*	m_pAsyncShellIcon;
};

extern bool g_fSmartIncludesWorkspace;

enum ModeType { MODE_SMART, MODE_FILESYSTEM, MODE_PROJECT, MODE_WORKSPACE, MODE_HISTORY, MODE_MAX };
enum ListType { LIST_FILESYSTEM, LIST_PROJECT, LIST_WORKSPACE, LIST_HISTORY, LIST_MAX, LIST_ALLLISTS = -1 };

extern "C" void VSAPI FlatFile_Uninitialize();

extern "C" void VSAPI FlatFile_ClearFiles( ListType iList = LIST_ALLLISTS );
extern "C" int VSAPI FlatFile_AllocateFileList( ListType iList, unsigned cFiles );
extern "C" void VSAPI FlatFile_SetRelativeDir( VSHVAR relativeDir );
extern "C" int VSAPI FlatFile_AppendFile( ListType iList, VSHVAR filename );
int FlatFile_AppendFileData( ListType iList, char const* pszDir, WIN32_FIND_DATA const* pfd );
extern "C" void VSAPI FlatFile_SortFiles( ListType iList );
extern "C" unsigned VSAPI FlatFile_Count( ListType iList );

extern "C" void VSAPI FlatFile_SetMode( ModeType iMode );
extern "C" int VSAPI FlatFile_GetMode();
unsigned Filter_Count();
FileInfo* Filter_GetFile( unsigned index );
unsigned Filter_ApplyFilter( char const* pszFilter );

char const* GetFileName( char const* pszFile );
char const* GetExtension( char const* pszFile );

