#pragma once

#include <commctrl.h>
#include "dlg.h"

class OpenDlg : public DlgBase
{
	typedef DlgBase base;

public:
					OpenDlg();
					~OpenDlg();

	INT_PTR			DoModal( HWND hwndParent );

	static void		SetPos( int x, int y, int cx, int cy );
	static void		UpdatePos( int x, int y, int cx, int cy );
	static bool		IsMoved() { return s_fMoved; }
	static int		GetX() { return s_x; }
	static int		GetY() { return s_y; }
	static int		GetCX() { return s_cx; }
	static int		GetCY() { return s_cy; }

protected:
	INT_PTR			DlgProc( UINT msg, WPARAM wParam, LPARAM lParam ) OVERRIDE;

	INT_PTR			ON_WM_INITDIALOG( WPARAM wParam, LPARAM lParam );
	INT_PTR			ON_WM_COMMAND( WPARAM wParam, LPARAM lParam );
	INT_PTR			ON_WM_SIZE( WPARAM wParam, LPARAM lParam );
	INT_PTR			ON_WM_MOVE( WPARAM wParam, LPARAM lParam );
	INT_PTR			ON_WM_NOTIFY( WPARAM wParam, LPARAM lParam );
	INT_PTR			ON_WM_SETFONT( WPARAM wParam, LPARAM lParam );
	INT_PTR			ON_WM_ICONAVAILABLE( WPARAM wParam, LPARAM lParam );

private:
	void			InitTabControl();
	void			InitFileList();
	void			InitFileListFont( HFONT hfont = 0 );
	bool			DoesListNeedReinitialized( char const* pszPath = 0, bool fCanUpdate = false );
	void			ReloadFileList();
	bool			AutoComplete( bool fBackslashPressed = false );
	bool			TryToOpenFile( bool fOpenExactText = false );

	void			RememberPos();

private:
	HIMAGELIST		m_himl;
	HIMAGELIST		m_himlSysSmallIcons;
	LONG			m_cyItem;
	Str				m_sCwd;
	Str				m_sInitFileListPath;
	Str				m_sToolTip;
	bool			m_fFileListControlInitialized;

private:
	static bool		s_fMoved;
	static int		s_x;
	static int		s_y;
	static int		s_cx;
	static int		s_cy;
};

